/**
 * Event arguments for the
 * editModeExited event.
*/
var IgcSpreadsheetEditModeExitedEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgcSpreadsheetEditModeExitedEventArgs() {
    }
    Object.defineProperty(IgcSpreadsheetEditModeExitedEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcSpreadsheetEditModeExitedEventArgs.prototype.onImplementationCreated = function () {
    };
    IgcSpreadsheetEditModeExitedEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgcSpreadsheetEditModeExitedEventArgs.prototype, "cell", {
        /**
         * Returns the cell for which the control has exitied edit mode.
        */
        get: function () {
            return this.i.cell;
        },
        enumerable: false,
        configurable: true
    });
    return IgcSpreadsheetEditModeExitedEventArgs;
}());
export { IgcSpreadsheetEditModeExitedEventArgs };
