import { Base, INotifyPropertyChanged, Nullable$1, PropertyChangedEventArgs, Type } from "igniteui-webcomponents-core";
import { ISupportPropertyChangeNotifications } from "./ISupportPropertyChangeNotifications";
import { ScrollInfoBarVisibility } from "./ScrollInfoBarVisibility";
import { ScrollInfoAmount } from "./ScrollInfoAmount";
import { ITypedPropertyChangeListener$2 } from "./ITypedPropertyChangeListener$2";
/**
 * @hidden
 */
export declare class ScrollInfo extends Base implements INotifyPropertyChanged, ISupportPropertyChangeNotifications {
    static $t: Type;
    private _f;
    private _k;
    private _c;
    constructor();
    private _d;
    get _g(): boolean;
    set _g(a: boolean);
    private _e;
    get _h(): boolean;
    set _h(a: boolean);
    private _l;
    get _t(): number;
    set _t(a: number);
    protected get__i(): boolean;
    get _i(): boolean;
    private _ag;
    get _ah(): Nullable$1<number>;
    set _ah(a: Nullable$1<number>);
    get _z(): number;
    private _m;
    get _aa(): number;
    private _n;
    get _ab(): number;
    set _ab(a: number);
    private _o;
    get _ac(): number;
    set _ac(a: number);
    private _a;
    get _b(): ScrollInfoBarVisibility;
    set _b(a: ScrollInfoBarVisibility);
    private _p;
    get _ad(): number;
    set _ad(a: number);
    private _q;
    get _ae(): number;
    set _ae(a: number);
    private _r;
    get _af(): number;
    set _af(a: number);
    private _ai;
    _s(a: ScrollInfoAmount): number;
    _u(): number;
    static _v(a: number, b: number, c: number, d: number): number;
    private _w;
    _x(): number;
    static _y(a: number, b: number): number;
    _aj(a: number, b: number, c: number): void;
    protected _ak(a: string): void;
    private _al;
    private _am;
    _ap(a: number): void;
    _an(a: ScrollInfoAmount): void;
    _ao(a: ScrollInfoAmount, b: number): void;
    _aq(a: number): void;
    _ar(a: number): void;
    private _j;
    private _as;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    addListener(a: ITypedPropertyChangeListener$2<any, string>, b: boolean): void;
    removeListener(a: ITypedPropertyChangeListener$2<any, string>): void;
}
