import { IgcCancelEventArgs } from "igniteui-webcomponents-core";
import { SpreadsheetContextMenuOpeningEventArgs as SpreadsheetContextMenuOpeningEventArgs_internal } from "./SpreadsheetContextMenuOpeningEventArgs";
import { SpreadsheetContextMenuArea } from "./SpreadsheetContextMenuArea";
/**
 * Event arguments for the
 * contextMenuOpening event.
*/
export declare class IgcSpreadsheetContextMenuOpeningEventArgs extends IgcCancelEventArgs {
    /**
                                 * @hidden
                                 */
    get i(): SpreadsheetContextMenuOpeningEventArgs_internal;
    constructor();
    /**
     * Returns the area for which the menu is being displayed
    */
    get menuArea(): SpreadsheetContextMenuArea;
}
