import { Base, Type } from "igniteui-webcomponents-core";
import { ISpreadsheetEditorValue } from "./ISpreadsheetEditorValue";
import { WorksheetCellFormatData } from "igniteui-webcomponents-excel";
import { IGFormattedTextDocument } from "./IGFormattedTextDocument";
/**
 * @hidden
 */
export declare class SpreadsheetEditorValue extends Base implements ISpreadsheetEditorValue {
    static $t: Type;
    private b;
    private a;
    constructor(a: string, b: WorksheetCellFormatData);
    get editCellFormat(): WorksheetCellFormatData;
    get unformattedText(): string;
    createDocument(): IGFormattedTextDocument;
}
